import time
import os
import re
import easygui
import spacy
import string
from pdf2image import convert_from_path
import pytesseract
class pdf_to_text():

    def __init__(self):
        script_dir = os.path.dirname(__file__)
        self.txt_path = os.path.join(script_dir, "..\\data\\train.txt")
        self.txt_path_keyextraction = os.path.join(script_dir, "..\\data\\train_for_keyextraction.txt")
        self.nlp = spacy.load("en_core_web_sm")
        self.special_characters = {
            '!', '"', '#', '$', '%', '&', '(', ')', '*',
            '+', '/', ':', ';', '<', '=', '>',
            '?', '@', '[', '\\', ']', '^', '_', '`', '{', '|',
            '}', '~', '¡', '¢', '£', '¤', '¥', '¦', '§', '¨',
            '©', 'ª', '«', '¬', '®', '¯', '°', '±', '²', '³',
            '´', 'µ', '¶', '·', '¸', '¹', 'º', '»', '¼', '½',
            '¾', '¿', '...', '..', '0', '1', '2', '3', '4', '5', '6',
            '7', '8', '9', '”', '—', '€','’'
        }


    def pdf_txt(self):

        # Abrimos una ventana para la seleccion del archivo pdf que queremos convertir
        pdf_path = easygui.fileopenbox()
        start_time = time.time()
        # Inicializa la salida de texto
        images = convert_from_path(pdf_path)
        text = ""

        for image in images:
            # Convierte la imagen en texto utilizando Tesseract OCR
            text += pytesseract.image_to_string(image)

        with open(self.txt_path, 'w', encoding='utf-8') as txt_file:
            txt_file.write(text)
            self.process_dataset_2() # Eliminamos espacios en blanco
            self.delete_simbols() #Eliminamos simbolos y números ya que no nos interesan
        end_time = time.time()
        elapsed_time = (end_time - start_time)/60
        print("tiempo de procesado de los pdf ", elapsed_time)

    def process_dataset(self):
        with open(self.txt_path, 'r', encoding='utf-8') as txt_file:
            text = txt_file.read()

        # Reemplaza múltiples espacios en blanco por uno solo y hacemos todas las palabras minúsculas
        text = ' '.join(text.lower().split())

        final_str = '' #variable donde guardaremos el texto final procesado para el Key extraction
        word = '' #Aquí guardaremos cada palabra encontrada para ver si existe

        for i in range(len(text)):
            if (text[i] in string.printable) :
                #Si encontrarmos una palabra que contiene un - y ese guion no es un guion entre espacios vacios.
                if 0 < i < len(text) - 2 and text[i - 1] != ' ' and text[i] == '-' and text[i + 1] == ' ': #Junta las palabras separadas por un salto de linea
                    j = i + 2 #Saltamos a la continuación de la palabra
                    new_word = word
                    while j < len(text) and text[j] != ' ':
                        new_word += text[j]
                        j += 1
                    doc = self.nlp(new_word)
                    if len(doc) == 1 and not doc[0].is_punct and not doc[0].is_space: #Miramos con spacy si existe new_word
                        final_str += new_word
                        i = j
                        word = ""
                    else:
                        word += text[i] #Si no existe new_word no intentamos juntar la palabra con guión

                elif text[i] == ' ': #Hemos encontrado una word nueva
                    word += text[i] #Añadimos el espacio en blanco
                    final_str += word
                    word = '' #Vaciamos word
                else:
                    word += text[i]
        # Manejar la última palabra
        final_str += word

        with open(self.txt_path, 'w', encoding='utf-8') as f:
            f.write(final_str)

    def process_dataset_2(self):
        with open(self.txt_path, 'r', encoding='utf-8') as txt_file:
            text = txt_file.read()

        # Reemplaza múltiples espacios en blanco por uno solo y hacemos todas las palabras minúsculas
        text = ' '.join(text.lower().split())

        final_str = ''  # Variable donde guardaremos el texto final procesado para el Key extraction
        word = ''  # Aquí guardaremos cada palabra encontrada para ver si existe
        i = 0
        while i < len(text):
            if text[i] == '-':
                # Si encontramos un guion
                if 0 < i < len(text) - 1 and text[i - 1] != ' ' and text[i + 1] == ' ':
                    # Junta las palabras separadas por un guion seguido de un espacio
                    j = i + 1  # Saltamos a la continuación de la palabra

                    while j < len(text) and text[j] != ' ':
                        word += text[j]
                        j += 1
                    doc = self.nlp(word)
                    if len(doc) == 1 and not doc[0].is_punct and not doc[0].is_space:
                        # Miramos con spacy si existe word
                        final_str += word
                        i = j  # Saltamos al final de la palabra compuesta
                        word = ""  # Reiniciamos la palabra actual
                        continue  # Saltamos al siguiente carácter sin aumentar i
            elif text[i] == ' ':
                # Hemos encontrado una nueva palabra
                word += text[i]  # Añadimos el espacio en blanco
                final_str += word  # Añadimos la palabra a final_str
                word = ''  # Reiniciamos la palabra actual
                i += 1
                continue  # Saltamos al siguiente carácter sin aumentar i
            word += text[i]  # Concatenamos el carácter actual a la palabra
            i += 1

        # Manejar la última palabra
        final_str += word

        with open(self.txt_path, 'w', encoding='utf-8') as f:
            f.write(final_str)
    def delete_simbols(self):
        with open(self.txt_path, 'r', encoding='utf-8') as fp:
            doc = fp.read()
        caracteres_especiales = [
            '!', '"', '#', '$', '%', '&', '(', ')', '*',
            '+', '/', ':', ';', '<', '=', '>',
            '?', '@', '[', '\\', ']', '^', '_', '`', '{', '|',
            '}', '~', '¡', '¢', '£', '¤', '¥', '¦', '§', '¨',
            '©', 'ª', '«', '¬', '®', '¯', '°', '±', '²', '³',
            '´', 'µ', '¶', '·', '¸', '¹', 'º', '»', '¼', '½',
            '¾', '¿', '...', '..', '0', '1', '2', '3', '4', '5', '6',
            '7', '8', '9'
        ]

        # Unir la lista de caracteres especiales en una expresión regular
        patron = re.compile('|'.join(re.escape(char) for char in caracteres_especiales))

        # Eliminar los caracteres especiales del texto
        doc = patron.sub('', doc)
        with open(self.txt_path_keyextraction, 'w', encoding='utf-8') as f:
            f.write(doc)
